<?php
/**
*
* @author FreakyBlue (David Jansen) freakyblue@idlaunch.org
* @package Download Centre
* @version $Id downloadcentre/category.php 0.0.6 2010-03-06 21:47:25GMT FreakyBlue $
* @copyright (c) 2009 FreakyBlue | http://www.IDLaunch.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

define('IN_PHPBB', true);
$phpbb_root_path = $downloadcentre_root_path = '';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . $downloadcentre_root_path . 'includes/root_path.' . $phpEx);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);

// Specify the language file we need
$user->setup('mods/downloadcentre');

$downloadcentre_root_path = DOWNLOADCENTRE_ROOT_PATH;

// Include specific functions for the downloadcentre
include($phpbb_root_path . $downloadcentre_root_path . 'includes/functions.' . $phpEx);

// Set up some general variables we need
$download_cat_id = request_var('id', 0);
$x = $y = 0;
$forums	= array_intersect(array_keys($auth->acl_getf('f_read', true)), array_keys($auth->acl_getf('f_download', true)));

// Let's get the download categories data from the database
$sql = 'SELECT download_cat_id, download_cat_title, download_cat_desc, download_cat_image, download_cat_order
		FROM ' . DOWNLOADCENTRE_CAT_TABLE . '
		GROUP BY download_cat_id
		ORDER BY download_cat_order ASC';
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{		
			// Add the template vars for the left side menu
			$template->assign_block_vars('download_cat_menu', array(
			'S_CAT_MENU'					=> true,
			'DOWNLOAD_CAT_TITLE_MENU'		=> $row['download_cat_title'],
			'DOWNLOAD_CAT_URL'				=> append_sid("{$phpbb_root_path}{$downloadcentre_root_path}category.$phpEx", 'id=' . $row['download_cat_id']),
			));
			
			// Let's narrow it down to one specific category			
			if ($download_cat_id == $row['download_cat_id'])
			{
				// Add the template vars for the middle download categories section
				$template->assign_vars(array(
				'S_CAT_DESC'				=> true,
				'DOWNLOAD_CAT_TITLE'		=> $row['download_cat_title'],
				'DOWNLOAD_CAT_IMAGE_SRC'	=> ($row['download_cat_image']) ? $phpbb_root_path . $row['download_cat_image'] : '',
				'DOWNLOAD_CAT_DESC'			=> $row['download_cat_desc'],
				));
					
				// Now we have done this, add some other template vars we need
				$template->assign_vars(array(
				'DOWNLOAD_CAT_TITLE'		=> $row['download_cat_title'],
				));
			}	
		}	
			
	$db->sql_freeresult($result);

// Get the download forums and the allowed preview images and explode them properly
$sql = 'SELECT download_cat_forums, download_cat_exclude
     	FROM ' . DOWNLOADCENTRE_CAT_TABLE . '
		WHERE download_cat_id = ' . $download_cat_id . '';
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$download_forums = explode(',', $row['download_cat_forums']);
		$exclude_files = explode(',', $row['download_cat_exclude']);
		$db->sql_freeresult($result);
	
// Pull the information from the database for the latest download version 
$sql = 'SELECT a.attach_id, a.topic_id, a.real_filename, a.extension, a.filesize, a.poster_id, a.filetime, a.download_count, a.post_msg_id, u.username, u.user_colour,	
		t.topic_title, t.topic_id, t.forum_id, d.download_cat_id, d.download_cat_preview, p.post_text, p.bbcode_bitfield, p.bbcode_uid
     	FROM ' . ATTACHMENTS_TABLE . ' a, ' . TOPICS_TABLE . ' t, ' . USERS_TABLE . ' u, ' . DOWNLOADCENTRE_CAT_TABLE . ' d, ' . POSTS_TABLE . ' p
		WHERE u.user_id = a.poster_id
       	AND a.topic_id = t.topic_id
		AND a.post_msg_id = p.post_id
       	AND a.in_message = 0
		AND d.download_cat_id = ' . $download_cat_id . '
		AND ' . $db->sql_in_set('t.forum_id', $download_forums) . '
		AND ' . $db->sql_in_set('t.forum_id', $forums) . '
		AND NOT ' . $db->sql_in_set('a.extension', $exclude_files) . '
		ORDER BY a.filetime DESC';
		$result = $db->sql_query($sql);
		if ($row = $db->sql_fetchrow($result))
		{
			
			// What to do if the category contains at least one file?
			if (!empty($row['attach_id']))
			{
				// Let's define what we want to see at the topic preview section
				$topic_text = $row['post_text'];
				$topic_preview = substr($topic_text, 0, 1000);
				$topic_preview_limit = generate_text_for_display($topic_preview, $row['bbcode_uid'], $row['bbcode_bitfield'], 7);
					
				// A visitor with download permission may pass and view the category
				if ($auth->acl_get('u_download'))
				{
					$template->assign_vars(array(
					'S_VIEW_LATEST'				=> true,
					'REALNAME'					=> clean_filename($row['real_filename']),
					'PREVIEW'					=> preview_images($row['download_cat_preview'], $row['extension'], $row['attach_id']),
					'TOPIC_PREVIEW'				=> $topic_preview_limit,
					'TOPIC_NAME'				=> $row['topic_title'],
					'TOPIC_URL'					=> append_sid($phpbb_root_path . 'viewtopic.' . $phpEx, 't=' . $row['topic_id']),
					'DATE'						=> $user->format_date($row['filetime'], 'D M d, Y g:i a'),
					'SIZE'						=> get_formatted_filesize($row['filesize']),
					'POSTER'					=> get_username_string('full', $row['poster_id'], $row['username'], $row['user_colour']),
					'DOWNLOADS'					=> $row['download_count'],
							
					'U_FILE'					=> append_sid($phpbb_root_path . 'download/file.' . $phpEx, 'id=' . $row['attach_id']),
					));	
				}
			}	
		}
		
		// What if the category is empty?
		if (empty($row['attach_id']))
			{
				$template->assign_vars(array(
				'S_EMPTY_CAT'				=> true,
				'S_NO_SHOW'					=> false,
				'EMPTY_CAT'					=> $user->lang['DOWNLOAD_CAT_EMPTY'],
				));
			}
		
		while ($row = $db->sql_fetchrow($result))
		{
		
			// Let's show the archive when it's not empty
			if (!empty($row['attach_id']))
			{	
				// A visitor with global download permission may pass and view the category
				if ($auth->acl_get('u_download'))
				{
					$x++;
					$y++;

					$template->assign_block_vars('download_cat', array(
					'S_ARCHIVE'					=> true,
					'REALNAME'					=> clean_filename($row['real_filename']),
					'PREVIEW'					=> preview_images($row['download_cat_preview'], $row['extension'], $row['attach_id']),
					'TOPIC_NAME'				=> $row['topic_title'],
					'TOPIC_URL'					=> append_sid($phpbb_root_path . 'viewtopic.' . $phpEx, 't=' . $row['topic_id']),
					'DATE'						=> $user->format_date($row['filetime'], 'D M d, Y g:i a'),
					'SIZE'						=> get_formatted_filesize($row['filesize']),
					'POSTER'					=> get_username_string('full', $row['poster_id'], $row['username'], $row['user_colour']),
					'DOWNLOADS'					=> $row['download_count'],
								
					'S_ROW'						=> $x % 3,
					'S_COL'						=> $y ,

					'U_FILE'					=> append_sid($phpbb_root_path . 'download/file.' . $phpEx, 'id=' . $row['attach_id']),
					));
				}
			}
		}
		
		// What if a visitor doesn't have the global download permission?
		if (!$auth->acl_get('u_download'))
		{
			$template->assign_vars(array(
			'S_NO_SHOW'				=> true,
			'NO_ACCESS'				=> $user->lang['NO_ACCESS_ATTACHMENT'],
			));
		}
		
		// What if the archive is empty?
		if (empty($row['attach_id']))
			{
				$template->assign_vars(array(
				'S_EMPTY_ARCHIVE'			=> true,
				'EMPTY_ARCHIVE'				=> $user->lang['DOWNLOAD_CAT_EMPTY_ARCHIVE'],
				));
			}		
	
	$db->sql_freeresult();
			
// Add some other general template vars we need
$template->assign_vars(array(
	'DOWNLOADCENTRE'			=> append_sid("{$phpbb_root_path}{$downloadcentre_root_path}index.$phpEx"),
	'IDLAUNCH'					=> append_sid("http://www.IDLaunch.org"),
	));
		
// Let's give this page a name
page_header($user->lang['DOWNLOADCENTRE'] . ' &bull; ' . $user->lang['DOWNLOADCENTRE_CATS']);

// Set up the navlinks
$template->assign_block_vars('navlinks', array(
	'FORUM_NAME'        => $user->lang['DOWNLOADCENTRE'],
	'U_VIEW_FORUM'      => append_sid("{$phpbb_root_path}{$downloadcentre_root_path}index.$phpEx"),
	));
				
$template->assign_block_vars('navlinks', array(
	'FORUM_NAME'        => $user->lang['DOWNLOADCENTRE_CATS'],
	));

// Specify the template file we're going to use
$template->set_filenames(array(
	'body' => 'downloadcentre/downloadcentre_category_body.html',
	));
	
page_footer();
?>