<?php
/**
*
* @author FreakyBlue (David Jansen) freakyblue@idlaunch.org
* @package Download Centre
* @version $Id downloadcentre/includes/functions.php 0.0.6 2010-03-06 21:46:25GMT FreakyBlue $
* @copyright (c) 2009 FreakyBlue | http://www.IDLaunch.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

if (!defined('IN_PHPBB'))
{
	exit;
}

/** 
*
* Functions included in this file
* 1. Preview Images
* 2. Clean Filename
*
*/

function preview_images ($activation, $extension, $id)
{
	global $phpbb_root_path, $phpEx;
	
	$image_files = array('png', 'jpg', 'gif', 'jpeg', 'tiff', 'tga', 'tif');
	$pre_defined = array('7z', 'gz', 'rar', 'tar', 'tgz', 'torrent', 'zip', 'ini', 'txt', 'xml', 'doc', 'pdf', 'ppt', 'rtf', 'xls', 'ram', 'rm', 'wma', 'wmv', 'swf', 'mov', 'mp4', 'qt', 'mp3', 'mpeg', 'mpg', 'ogg');
	$archive_files = array('ace', 'bz2', 'gtar');
	$text_files = array('c', 'cpp', 'csv', 'diz', 'h', 'hpp', 'js', 'log');
	$document_files = array('ai', 'docm', 'docx', 'dot', 'dotm', 'dotx', 'odg', 'odp', 'ods', 'odt', 'pptm', 'pptx', 'ps', 'xlsb', 'xlsm', 'xlsx');
	$qt_files = array('3gp', '3g2', 'm4a', 'm4v', 'ogm');
	
	if ($activation == 1)
	{
		if (in_array($extension, $image_files))
		{
		$preview = append_sid($phpbb_root_path . 'download/file.' . $phpEx, 'id=' . $id . '&amp;mode=view');
		}
		elseif (in_array($extension, $pre_defined))
		{
		$preview = sprintf(append_sid($phpbb_root_path . 'downloadcentre/images/' . $extension .'.png'));
		}
		elseif (in_array($extension, $archive_files))
		{
		$preview = sprintf(append_sid($phpbb_root_path . 'downloadcentre/images/archive.png'));
		}
		elseif (in_array($extension, $text_files))
		{
		$preview = sprintf(append_sid($phpbb_root_path . 'downloadcentre/images/textfiles.png'));
		}
		elseif (in_array($extension, $document_files))
		{
		$preview = sprintf(append_sid($phpbb_root_path . 'downloadcentre/images/documents.png'));
		}
		elseif (in_array($extension, $qt_files))
		{
		$preview = sprintf(append_sid($phpbb_root_path . 'downloadcentre/images/quicktime.png'));
		}
	}
	else
	{
		$preview = '';
	}
			
	return($preview);

}

function clean_filename ($filename)
{
	$real_filename = ucfirst(strtolower($filename));
	$info = pathinfo($real_filename);
	$real_name =  basename($real_filename,'.'.$info['extension']);
	$clean_filename = preg_replace("/[^a-zA-Z0-9\s]/", "", ($real_name));
	
	return($clean_filename);
}
?>