<?php
/**
*
* @author FreakyBlue (David Jansen) freakyblue@idlaunch.org
* @package Download Centre
* @version $Id downloadcentre/index.php 0.0.6 2010-03-06 21:47:25GMT FreakyBlue $
* @copyright (c) 2009 FreakyBlue | http://www.IDLaunch.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

define('IN_PHPBB', true);
$phpbb_root_path = $downloadcentre_root_path = '';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . $downloadcentre_root_path . 'includes/root_path.' . $phpEx);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);

// Specify the language file we need
$user->setup('mods/downloadcentre');

$downloadcentre_root_path = DOWNLOADCENTRE_ROOT_PATH;

// Let's get the download categories data from the database
$sql = 'SELECT download_cat_id, download_cat_title, download_cat_desc, download_cat_image, download_cat_order
		FROM ' . DOWNLOADCENTRE_CAT_TABLE . '
		GROUP BY download_cat_id
		ORDER BY download_cat_order ASC';
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{	
			// Add the template vars for the left side menu
			$template->assign_block_vars('download_cat_menu', array(
			'DOWNLOAD_CAT_TITLE_MENU'		=> $row['download_cat_title'],
			'DOWNLOAD_CAT_URL'				=> append_sid("{$phpbb_root_path}{$downloadcentre_root_path}category.$phpEx", 'id=' . $row['download_cat_id']),
			));
			
			// Add the template vars for the middle download categories section
			$template->assign_block_vars('download_cat', array(
			'DOWNLOAD_CAT_ID'			=> $row['download_cat_id'],
			'DOWNLOAD_CAT_TITLE'		=> $row['download_cat_title'],
			'DOWNLOAD_CAT_DESC'			=> $row['download_cat_desc'],
			'DOWNLOAD_CAT_IMAGE_SRC'	=> ($row['download_cat_image']) ? $phpbb_root_path . $row['download_cat_image'] : '',
			'DOWNLOAD_CAT_ORDER'		=> $row['download_cat_order'],
			'DOWNLOAD_CAT_URL'			=> append_sid("{$phpbb_root_path}{$downloadcentre_root_path}category.$phpEx", 'id=' . $row['download_cat_id']),
			'DOWNLOAD_CAT_STATS'		=> append_sid("{$phpbb_root_path}{$downloadcentre_root_path}stats.$phpEx", 'id=' . $row['download_cat_id']),
				
			));	
		}		
	
	$db->sql_freeresult($result);
			
// Set the Page Title 
page_header($user->lang['DOWNLOADCENTRE']);

// Add some other general template vars we need
$template->assign_vars(array(
	'DOWNLOADCENTRE'			=> append_sid("{$phpbb_root_path}{$downloadcentre_root_path}index.$phpEx"),
	'IDLAUNCH'					=> append_sid("http://www.IDLaunch.org"),
	));

// Set up the navlinks
$template->assign_block_vars('navlinks', array(
	'FORUM_NAME'         	=> $user->lang['DOWNLOADCENTRE'],
	'U_VIEW_FORUM'      	=> append_sid("{$phpbb_root_path}{$downloadcentre_root_path}index.$phpEx"),
	));

// This template file are we going to use
$template->set_filenames(array(
   'body' => 'downloadcentre/downloadcentre_index_body.html',
	));

page_footer();
?>