<?php
/**
*
* @author FreakyBlue (David Jansen) freakyblue@idlaunch.org
* @package Download Centre
* @version $Id downloadcentre/stats.php 0.0.6 2010-03-06 21:47:01GMT FreakyBlue $
* @copyright (c) 2009 FreakyBlue | http://www.IDLaunch.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

define('IN_PHPBB', true);
$phpbb_root_path = $downloadcentre_root_path = '';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . $downloadcentre_root_path . 'includes/root_path.' . $phpEx);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);

// Specify the language file we need
$user->setup('mods/downloadcentre');

// Set up some variables we need some later on
$download_cat_id = request_var('id', 0);
$attach_id = request_var('id', 0);
$forums	= array_intersect(array_keys($auth->acl_getf('f_read', true)), array_keys($auth->acl_getf('f_download', true)));

$downloadcentre_root_path = DOWNLOADCENTRE_ROOT_PATH;

// Include specific functions for the downloadcentre
include($phpbb_root_path . $downloadcentre_root_path . 'includes/functions.' . $phpEx);

// Let's get the download categories data from the database
$sql = 'SELECT download_cat_id, download_cat_title, download_cat_desc, download_cat_image, download_cat_order
		FROM ' . DOWNLOADCENTRE_CAT_TABLE . '
		GROUP BY download_cat_id
		ORDER BY download_cat_order ASC';
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{		
			// Add the template vars for the left side menu
			$template->assign_block_vars('download_cat_menu', array(
			'DOWNLOAD_CAT_TITLE_MENU'		=> $row['download_cat_title'],
			'DOWNLOAD_CAT_URL'				=> append_sid("{$phpbb_root_path}{$downloadcentre_root_path}stats.$phpEx", 'id=' . $row['download_cat_id']),
			));
			
			// Let's narrow it down to one specific category
			if ($download_cat_id == $row['download_cat_id'])
			{
				// Now we have done this, add the template vars for the download categories
				$template->assign_block_vars('download_cat', array(
				'DOWNLOAD_CAT_TITLE'		=> $row['download_cat_title'],
				'DOWNLOAD_CAT_IMAGE_SRC'	=> ($row['download_cat_image']) ? $phpbb_root_path . $row['download_cat_image'] : '',
				));
				
				// Now we have done this, add some other template vars we need
				$template->assign_vars(array(
				'DOWNLOAD_CAT_TITLE'		=> $row['download_cat_title'],
				));
			}	
		}	
			
	$db->sql_freeresult($result);
			
// Get the download forums and the allowed preview images and explode them properly
$sql = 'SELECT download_cat_forums, download_cat_exclude
     	FROM ' . DOWNLOADCENTRE_CAT_TABLE . '
		WHERE download_cat_id = ' . $download_cat_id . '';
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$download_forums = explode(',', $row['download_cat_forums']);
		$exclude_files = explode(',', $row['download_cat_exclude']);
		$db->sql_freeresult($result);

// Set up the basic query for the attach stats
$sql = 'SELECT COUNT(a.attach_id) as attach_count, a.attach_id, a.real_filename, a.filesize, a.filetime, a.download_count, u.username, u.user_colour, a.poster_id, t.forum_id
		FROM ' . ATTACHMENTS_TABLE . ' a, ' . TOPICS_TABLE . ' t, ' . USERS_TABLE . ' u, ' . DOWNLOADCENTRE_CAT_TABLE . ' d
		WHERE ' . $db->sql_in_set('t.forum_id', $download_forums) . '
		AND a.is_orphan = 0
		AND u.user_id = a.poster_id
		AND a.topic_id = t.topic_id
		AND d.download_cat_id = ' . $download_cat_id . '
		AND ' . $db->sql_in_set('t.forum_id', $forums) . '
		AND NOT ' . $db->sql_in_set('a.extension', $exclude_files) . '
		GROUP BY a.attach_id
		ORDER BY a.attach_id DESC';
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
		
			// Let's show some stats when there are any to show
			if (!empty($row['attach_id']))
			{	
				// A visitor with global download permission may pass and view the file stats
				if ($auth->acl_get('u_download'))
				{
					$template->assign_block_vars('stats', array(
					'S_CAT_STATS'				=> true,
					'FILENAME'					=> clean_filename($row['real_filename']),
					'FILESIZE'					=> get_formatted_filesize($row['filesize']),
					'FILETIME'					=> $user->format_date($row['filetime'], 'D M d, Y g:i a'),
					'DOWNCOUNT'					=> $row['download_count'],
					'POSTER'					=> get_username_string('full', $row['poster_id'], $row['username'], $row['user_colour']),
					));
				}
			}
		}
		
		// What if a visitor doesn't have the global download permission?
		if (!$auth->acl_get('u_download'))
		{
			$template->assign_vars(array(
			'S_NO_SHOW'				=> true,
			'NO_ACCESS'				=> $user->lang['NO_ACCESS_STATS'],
			));
		}
		
		// What if there are no files and stats to show yet?
		if (empty($row['attach_id']))
			{
				$template->assign_vars(array(
				'S_EMPTY_STATS'				=> true,
				'EMPTY_STATS'				=> $user->lang['NO_STATS'],
				));
			}		
	
	$db->sql_freeresult();

// Arrange a query for the attach count
$sql = 'SELECT COUNT(a.attach_id) as attach_count, SUM(a.filesize), SUM(a.download_count)
		FROM ' . ATTACHMENTS_TABLE . ' a, ' . TOPICS_TABLE . ' t, ' . USERS_TABLE . ' u, ' . DOWNLOADCENTRE_CAT_TABLE . ' d
		WHERE ' . $db->sql_in_set('t.forum_id', $download_forums) . '
		AND u.user_id = a.poster_id
		AND a.topic_id = t.topic_id
		AND d.download_cat_id = ' . $download_cat_id . '
		AND ' . $db->sql_in_set('t.forum_id', $forums) . '
		AND NOT ' . $db->sql_in_set('a.extension', $exclude_files) . '
		GROUP BY d.download_cat_id
		ORDER BY a.attach_id';
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult();

		$total_files = $row['attach_count'];
		$total_size = get_formatted_filesize($row['SUM(a.filesize)']);
		$total_downloads = $row['SUM(a.download_count)'];
		
		// What if there are no files yet in the category?
		if (empty($total_files))
		{
			$template->assign_vars(array(
			'S_EMPTY_CAT_STATS'	=> true,
			'NO_CAT_STATS'		=> $user->lang['NO_CAT_STATS'],
			
			'DOWNLOADCENTRE'	=> append_sid("{$phpbb_root_path}{$downloadcentre_root_path}index.$phpEx"),
			'IDLAUNCH'			=> append_sid("http://www.IDLaunch.org"),
			));
		}
		else
		{
		
			// Let's get the top poster per category
			$sql = 'SELECT a.poster_id, COUNT(a.poster_id) as top_poster, u.username, u.user_colour
					FROM ' . ATTACHMENTS_TABLE . ' a, ' . TOPICS_TABLE . ' t, ' . USERS_TABLE . ' u, ' . DOWNLOADCENTRE_CAT_TABLE . ' d
					WHERE ' . $db->sql_in_set('t.forum_id', $download_forums) . '
					AND u.user_id = a.poster_id
					AND a.topic_id = t.topic_id
					AND d.download_cat_id = ' . $download_cat_id . '
					GROUP BY a.poster_id
					ORDER BY top_poster DESC';
					$result = $db->sql_query($sql);
					$row = $db->sql_fetchrow($result);
					$db->sql_freeresult();
						
					// Now we have done this, add the template vars we need
					$template->assign_vars(array(
					'S_SHOW_CAT_STATS'	=> true,
					'TOTAL_FILES'		=> $total_files,
					'TOTAL_SIZE'		=> $total_size,
					'TOTAL_DOWNLOADS'	=> $total_downloads,
					'TOP_POSTER'		=> get_username_string('full', $row['poster_id'], $row['username'], $row['user_colour']),

					'DOWNLOADCENTRE'	=> append_sid("{$phpbb_root_path}{$downloadcentre_root_path}index.$phpEx"),
					'IDLAUNCH'			=> append_sid("http://www.IDLaunch.org"),
					));
		}
		
// Let's give this page a name
page_header($user->lang['DOWNLOADCENTRE'] . ' &bull; ' . $user->lang['DOWNLOADCENTRE_STATS']);

// Set up the navlinks
$template->assign_block_vars('navlinks', array(
	'FORUM_NAME'        => $user->lang['DOWNLOADCENTRE'],
	'U_VIEW_FORUM'      => append_sid("{$phpbb_root_path}{$downloadcentre_root_path}index.$phpEx"),
	));
				
$template->assign_block_vars('navlinks', array(
	'FORUM_NAME'        => $user->lang['DOWNLOADCENTRE_STATS'],
	));

// Specify the template file we're going to use
$template->set_filenames(array(
	'body' => 'downloadcentre/downloadcentre_stats_body.html',
	));

page_footer();
?>