<?php
/**
*
* @author FreakyBlue (David Jansen) freakyblue@idlaunch.org
* @package Download Centre
* @version $Id includes/acp/info/acp_downloadcentre.php 0.0.6 2010-03-06 21:44:05GMT FreakyBlue $
* @copyright (c) 2009 FreakyBlue | http://www.IDLaunch.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package module_install
*/
class acp_downloadcentre_info
{
	function module()
	{		
		return array(
			'filename'	=> 'acp_downloadcentre',
			'title'		=> 'ACP_DOWNLOADCENTRE',
			'version'	=> '0.0.6',
			'modes'		=> array(
				'downloadcentre'	=> array(
					'title'			=> 'ACP_DOWNLOADCENTRE_MANAGER',
					'auth'			=> 'acl_a_board',
					'cat'			=> array('ACP_BOARD_CONFIGURATION')),
			),
		);
	}
		
	function install($u_action)
	{
		global $phpbb_root_path, $phpEx, $db, $user;

		// Setup $auth_admin class so we can add permission options
		include($phpbb_root_path . 'includes/acp/auth.' . $phpEx);
		$auth_admin = new auth_admin();

		// Add permission for manage cvsdb
		$auth_admin->acl_add_option(array(
			'local'		=> array(),
			'global'	=> array('a_manage_downloadcentre')
		));

		$module_data = $this->module();

		$module_basename = substr(strchr($module_data['filename'], '_'), 1);

		$sql = 'SELECT module_id
				FROM ' . MODULES_TABLE . "
				WHERE module_basename = '$module_basename'";
		$result = $db->sql_query($sql);
		$module_id = $db->sql_fetchfield('module_id');
		$db->sql_freeresult($result);

		$sql = 'UPDATE ' . MODULES_TABLE . " SET module_auth = 'acl_a_manage_downloadcentre' WHERE module_id = $module_id";
		$db->sql_query($sql);

		set_config('downloadcentre_version', $module_data['version']);

		trigger_error(sprintf($user->lang['DOWNLOADCENTRE_MOD_INSTALLED'], $module_data['version']) . adm_back_link($u_action));
	}

	function uninstall()
	{
	}
	
	function update($u_action)
	{
		global $user;
		
		$module_data = $this->module();
		
		set_config('downloadcentre_version', $module_data['version']);
		
		trigger_error(sprintf($user->lang['DOWNLOADCENTRE_MOD_UPDATED'], $module_data['version']) . adm_back_link($u_action));
	}
	
}

?>